#ifndef AUDIO_HPP
#define AUDIO_HPP


#include <windows.h>


struct DRIVERINFO
{
  const char* name;
  const char* author;
  const char* date;
  const char* version;
  const char* description;
};


extern HINSTANCE DriverInstance;


void GetDriverConfigFile(char* config_file);


// exports

#define EXPORT  __stdcall
#define SA_CALL __stdcall


typedef struct SA_SOUNDimp* SA_SOUND;

typedef void* (SA_CALL * SA_FileOpenCallback)(const char* filename);
typedef void  (SA_CALL * SA_FileCloseCallback)(void* file);
typedef int   (SA_CALL * SA_FileReadCallback)(void* file, int bytes, void* buffer);
typedef void  (SA_CALL * SA_FileSeekCallback)(void* file, int position);
typedef int   (SA_CALL * SA_FileTellCallback)(void* file);
typedef int   (SA_CALL * SA_FileSizeCallback)(void* file);



void EXPORT SA_GetDriverInfo(DRIVERINFO* driverinfo);
void EXPORT SA_ConfigureDriver(HWND parent);

bool EXPORT SA_InitDriver(HWND window);
void EXPORT SA_CloseDriver(void);

void  EXPORT SA_SetPrivate(void* data);
void* EXPORT SA_GetPrivate(void);
void  EXPORT SA_SetFileCallbacks(
  SA_FileOpenCallback  open,
  SA_FileCloseCallback close,
  SA_FileReadCallback  read,
  SA_FileSeekCallback  seek,
  SA_FileTellCallback  tell,
  SA_FileSizeCallback  size);

SA_SOUND EXPORT SA_LoadSound(const char* filename);
void     EXPORT SA_DestroySound(SA_SOUND sound);
void     EXPORT SA_PlaySound(SA_SOUND sound, bool repeat);
void     EXPORT SA_StopSound(SA_SOUND sound);
void     EXPORT SA_SetVolume(SA_SOUND sound, int volume);
int      EXPORT SA_GetVolume(SA_SOUND sound);
int      EXPORT SA_GetLength(SA_SOUND sound);
void     EXPORT SA_SetPosition(SA_SOUND sound, int position);
int      EXPORT SA_GetPosition(SA_SOUND sound);

// end exports


#endif
