#include "../common/audio.hpp"


struct SA_SOUNDimp {
  void* reserved;
};


static void* s_private_data;


////////////////////////////////////////////////////////////////////////////////

void EXPORT SA_GetDriverInfo(DRIVERINFO* driverinfo)
{
  driverinfo->name        = "Null Audio Driver";
  driverinfo->author      = "Chad Austin";
  driverinfo->date        = __DATE__;
  driverinfo->version     = "1.00";
  driverinfo->description = "Does absolutely nothing!";
}

////////////////////////////////////////////////////////////////////////////////

void EXPORT SA_ConfigureDriver(HWND parent)
{
  MessageBox(parent, "No options", "Null Audio Driver", MB_OK);
}

////////////////////////////////////////////////////////////////////////////////

bool EXPORT SA_InitDriver(HWND window)
{
  return true;
}

////////////////////////////////////////////////////////////////////////////////

void EXPORT SA_CloseDriver()
{
}

////////////////////////////////////////////////////////////////////////////////

void EXPORT SA_SetPrivate(void* data)
{
  s_private_data = data;
}

////////////////////////////////////////////////////////////////////////////////

void* EXPORT SA_GetPrivate()
{
  return s_private_data;
}

////////////////////////////////////////////////////////////////////////////////

void  EXPORT SA_SetFileCallbacks(
  SA_FileOpenCallback  open,
  SA_FileCloseCallback close,
  SA_FileReadCallback  read,
  SA_FileSeekCallback  seek,
  SA_FileTellCallback  tell,
  SA_FileSizeCallback  size)
{
}

////////////////////////////////////////////////////////////////////////////////

SA_SOUND EXPORT SA_LoadSound(const char* filename)
{
  return new SA_SOUNDimp;
}

////////////////////////////////////////////////////////////////////////////////

void EXPORT SA_DestroySound(SA_SOUND sound)
{
  delete sound;
}

////////////////////////////////////////////////////////////////////////////////

void EXPORT SA_PlaySound(SA_SOUND sound, bool repeat)
{
}

////////////////////////////////////////////////////////////////////////////////

void EXPORT SA_StopSound(SA_SOUND sound)
{
}

////////////////////////////////////////////////////////////////////////////////

void EXPORT SA_SetVolume(SA_SOUND sound, int volume)
{
}

////////////////////////////////////////////////////////////////////////////////

int EXPORT SA_GetVolume(SA_SOUND sound)
{
  return 1;
}

////////////////////////////////////////////////////////////////////////////////

int EXPORT SA_GetLength(SA_SOUND sound)
{
  return 1;
}

////////////////////////////////////////////////////////////////////////////////

void EXPORT SA_SetPosition(SA_SOUND sound, int position)
{
}

////////////////////////////////////////////////////////////////////////////////

int EXPORT SA_GetPosition(SA_SOUND sound)
{
  return 0;
}

////////////////////////////////////////////////////////////////////////////////

int EXPORT SA_IsPlaying(SA_SOUND sound)
{
  return 0;
}

////////////////////////////////////////////////////////////////////////////////
