#ifndef T_HPP
#define T_HPP


#include "PaletteWindow.hpp"
#include "../common/Spriteset.hpp"
#include "DIBSection.hpp"


class CMainWindow;


class CSpritePreviewPalette : public CPaletteWindow
{
  CSpritePreviewPalette(CWnd* parent, CDocumentWindow* owner, sSpriteset* spriteset);
  ~CSpritePreviewPalette();

public:
  void Destroy();

  void SpriteSizeChanged();
  void SetDirection(int direction);
  void RefreshFrame();
  int  GetCurrentFrame();
  int  GetNumFrames();

private:
  afx_msg void OnPlay();
  afx_msg void OnStop();

  afx_msg void OnSize(UINT type, int cx, int cy);
  afx_msg void OnPaint();
  afx_msg void OnTimer(UINT nIDEvent);

private:
  bool         m_Created;
  int          m_AspectRatio;

  CButton      m_PlayButton;
  CButton      m_StopButton;
  CDIBSection* m_DrawBitmap;

  sSpriteset*  m_Spriteset;
  int          m_MaxDirection;
  int          m_MaxFrame;
  int          m_Direction;
  int          m_FrameNum;
  int          m_FrameDelay;
  int          m_DelayCounter;

  DECLARE_MESSAGE_MAP()
};


#endif
