#ifndef TILE_PREVIEW_PALETTE_HPP
#define TILE_PREVIEW_PALETTE_HPP


#include "PaletteWindow.hpp"
#include "../common/Tileset.hpp"
#include "DIBSection.hpp"


class CTilePreviewPalette : public CPaletteWindow
{
  CTilePreviewPalette(CWnd* parent, CDocumentWindow* owner, sTileset* tileset);
  ~CTilePreviewPalette();

public:
  void Destroy();

  void SetTile(int tile);
  void RefreshTile();
  int  GetCurrentTile();

private:
  afx_msg void OnPlay();
  afx_msg void OnStop();

  afx_msg void OnSize(UINT type, int cx, int cy);
  afx_msg void OnPaint();
  afx_msg void OnTimer(UINT nIDEvent);

private:
  bool         m_Created;
  int          m_AspectRatio;

  CButton      m_PlayButton;
  CButton      m_StopButton;
  CDIBSection* m_DrawBitmap;

  sTileset*    m_Tileset;
  int          m_TileNum;
  int          m_AnimTileNum;
  int          m_TileDelay;
  int          m_DelayCounter;

  DECLARE_MESSAGE_MAP()
};


#endif
