#include <algorithm>
#include "rendersort.hpp"


////////////////////////////////////////////////////////////////////////////////

void
CRenderSort::AddObject(int draw_x, int draw_y, int sort_y, IMAGE image)
{
  Object object;
  object.draw_x = draw_x;
  object.draw_y = draw_y;
  object.sort_y = sort_y;
  object.image  = image;
  m_objects.push_back(object);
}

////////////////////////////////////////////////////////////////////////////////

void
CRenderSort::DrawObjects()
{
  struct Local {
    static inline bool CompareObjects(const Object& a, const Object& b) {
      return (a.sort_y < b.sort_y);
    }
  };

  // sort the object list
  std::stable_sort(
    m_objects.begin(),
    m_objects.end(),
    Local::CompareObjects
  );

  // draw images to screen
  for (int i = 0; i < m_objects.size(); i++) {
    Object& o = m_objects[i];
    BlitImage(o.image, o.draw_x, o.draw_y);
  }

  m_objects.clear();
}

////////////////////////////////////////////////////////////////////////////////
