EvaluateSystemScript("screen.js");
EvaluateSystemScript("audio.js");
EvaluateSystemScript("menu.js");
EvaluateSystemScript("colors.js");


function game()
{
  intro();
  main_menu();
}


function intro()
{
  var image = LoadSurface("intro.jpeg");
  var sound = LoadSound("intro.wav");
  image.rescale(GetScreenWidth(), GetScreenHeight());
  image = image.createImage();

  image.blit(0, 0);
  FadeIn(500);
  
  sound.play(false);
  
  while (!AreKeysLeft()) {
    image.blit(0, 0);
    FlipScreen();
  }
  GetKey();
  
  image.blit(0, 0);
  FadeOut(500);
  ApplyColorMask(Black);  // FadeOut() leaves the backbuffer in place
  
  sound.stop();
}


function main_menu()
{
  var font         = GetSystemFont();
  var window_style = GetSystemWindowStyle();
  var arrow        = GetSystemArrow();
  var up_arrow     = GetSystemUpArrow();
  var down_arrow   = GetSystemDownArrow();
  
  // load the game list
  var game_list = GetGameList();
  if (game_list.length == 0) {
    font.drawText(0, 0, "No games detected");
    FlipScreen();
    GetKey();
    return;
  }
  
  // create the menu object
  var menu = new Menu();
  menu.escape_function = Exit;
  
  // add all of the games to the object
  for (var i = 0; i < game_list.length; i++) {
    var o = game_list[i];
    menu.addItem(o.name, new Function("ExecuteGame('" + o.directory + "')"));
  }

  while (true) {
    font.setColorMask(Red);
    font.drawText(4, 4, "Sphere " + GetVersionString());
    font.setColorMask(White);
    font.drawText(4, 20, "Chad Austin (c) 1997-2001");
    menu.execute(16, 48, GetScreenWidth() - 32, GetScreenHeight() - 64);
  }
}
